DailyItem_ADDONNAME = "DailyItems";
DailyItem_MACRONAME = "DailyItem";
DailyItem_VERSION = "2.0.4";
DI_Paranoia = 0;

SLASH_DAILYITEM1, SLASH_DAILYITEM2 = '/dailyitem', '/di';
function SlashCmdList.DAILYITEM(msg)
	if (strlower(msg) == "zone") then
		DailyItem_Print("Zone = ["..GetRealZoneText().."]");
		DailyItem_Print("SubZone = ["..GetSubZoneText().."]");
	elseif (strlower(msg) == "update") then
		print ("Force update");
		DI_Paranoia = 1;
		DailyItem_Go();
	elseif (strlower(msg) == "add") then
		print ("Recreate Macro");
		DailyItem_MakeMacro(); -- Used to debug the macro creation
	elseif (strlower(msg) == "quiet") then
		DI_Paranoia = 0;
	elseif (strlower(msg) == "normal") then
		DI_Paranoia = 2;
	elseif (strlower(msg) == "super") then
		DI_Paranoia = 5;
	elseif (strlower(msg) == "trick") then
		print ("Adding blacksmith hammer Item to database" );
DailyItem_AddArrayLine(nul,nul,5956,nul,0,nul);--Blacksmith Hammer()
DailyItem_AddArrayLine(nul,nul,2862,nul,0,29433);--Rough Sharpening Stone(Test Your Stength)
DailyItem_AddArrayLine(nul,nul,1251,"Raider's Training Dummy",1,29433);--Linen Bandage(Test Your Stength)
DailyItem_AddArrayLine(nul,nul,2901,"Training Dummy",0,29433);--Mining Pick(Test Your Stength)

	else
		print ("Daily item slash commands are");
		print ("Zone        Show the zone and subzone you are in ");
		print ("update      Show which macro it has selected ");
		print ("normal      Show you if it didnt actually find quest to create a macro for");
		print ("super       Super noisy - shows you everything ");
		print ("macro       Recreate the base macro - just in case you delete it");
		print ("Trick       Add some false items to the database (for debug you'll have to reload to get rid of them )");
		print ("quiet       Turns off the detailed messages turned on by update");
		print ("What you entered was '", msg, "'")
	end

end

-- I want this to run when you log in, update bag contents, swap zones, or change targets.

function DailyItem_OnLoad(self)
	self:RegisterEvent("PLAYER_LOGIN");
	self:RegisterEvent("BAG_UPDATE");  -- Something added to bag
	self:RegisterEvent("ZONE_CHANGED");
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
end

function DailyItem_MakeMacro()
	if (GetMacroIndexByName(DailyItem_MACRONAME) == 0) then
		local numGenMacros, numCharMacros = GetNumMacros();
		if (numGenMacros < 36) then
			CreateMacro(DailyItem_MACRONAME, "INV_MISC_QUESTIONMARK" , "", nil)
		else
			DailyItem_Print("You have 36 General Macros. Cannot add "..DailyItem_MACRONAME.."!");
		end
	end
end

-- Accessor functions
function DI_Zone(index)
	return DailyItem_Quests[index][1];
end
function DI_SubZone(index)
	return DailyItem_Quests[index][2];
end
function DI_Item(index)
	return DailyItem_Quests[index][3];
end
function DI_Target(index)
	return DailyItem_Quests[index][4];
end
function DI_TargetType(index)
	return DailyItem_Quests[index][5];
end
function DI_Quest(index)
	return DailyItem_Quests[index][6];
end

function DailyItem_OnEvent(self, event)
	if (InCombatLockdown()) then return; end

	if (event == "PLAYER_LOGIN") then
		DailyItem_MakeMacro();
		DailyItem_MakeArrays();
		DIQuestsLength = table.getn(DailyItem_Quests);
		DailyItem_Print("DailyItems Databese:\nQuests - "..DIQuestsLength);
	end
	DailyItem_Go();
end

function DailyItem_Print(msg)
	if ((msg) and (strlen(msg) > 0)) then
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
		end
	end
end

function DailyItem_NumFromLink(itemLink)
	if (not itemLink) then
		return nil;
	end
	local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
	return itemNumber;
end

function DailyItem_IsZone(index)
	if (not DI_Zone(index)) or (DI_Zone(index) == GetRealZoneText()) then
		return true;
	else
		return false;
	end
end

function DailyItem_IsSubZone(index)
	if (not DI_SubZone(index)) or (DI_SubZone(index) == GetSubZoneText()) then
		return true;
	else
		return false;
	end
end

function DailyItem_IsItemInBags(itemID)
	for bagID = 0, 4, 1 do
		local bagSlotCnt = GetContainerNumSlots(bagID);
		if (bagSlotCnt > 0) then
			for slot = 1, bagSlotCnt, 1 do
				local itemLink = GetContainerItemLink(bagID, slot);
				local itemNumber = tonumber(DailyItem_NumFromLink(itemLink));
				if (itemNumber) and (itemID == itemNumber) then
			if DI_Paranoia >2 then print("We found ", itemID, " In bag ", bigID, " slot " , slot); end
					return true;
				end
			end
		end
	end
	return false;
end

function DailyItem_IsItemWorn(itemID)
	for equipID = 0, 19, 1 do
		local itemNumber = GetInventoryItemID("player",equipID);
		if (itemNumber) then
			if (itemID == itemNumber) then
		if DI_Paranoia >2 then print("We found ", itemID, " In slot ", equipID); end
				return true;
			end
		end
	end
	return false;
end

function DailyItem_IsMatchTarget(index)
	-- if there is no target to look for or we are going to target then we have a match
	if DI_Paranoia>3 then print("Checking if ", DI_Target(index) ,"or",  DI_TargetType(index) ,"~=0 ") ; end
	if not DI_Target(index) or DI_TargetType(index) ~=0 then
		return true;
	else -- otherwise return if the current target matches what we want
		if DI_Paranoia>3 then print("Checking if ", DI_Target(index) ,"== ",UnitName("target") ) ; end
		return DI_Target(index) == UnitName("target");
	end
end


function DailyItem_IsMatchQuest(index)
	-- if its just an item without a quest then it matches
	if not DI_Quest(index) then
		return true;
	end
	local numQuests = GetNumQuestLogEntries(); -- Get the number of quests in my quest log
	for questNo = 1, numQuests -- Now, cycle through each quest in the quest log
	do
		--local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questNo); -- Get the information about each line in the quest log
		-- So I know which parts i look at commented out the parts I dont use
		local _ , _ , _ , _ , isHeader, _ , isComplete, _ = GetQuestLogTitle(questNo); -- Get the information about each line in the quest log
		if (not isHeader) then-- Ignore the lines that are just headers rather than actual quests
			local questID = tonumber(GetQuestLink(questNo):match("\124Hquest:(%d+):")); -- Get the actual quest ID
			if ((isComplete) and (questID + DI_Quest(index) == 0)) or ((not isComplete) and (questID == DI_Quest(index))) then -- Check if the current DB line matches the current quest (Negative means match complete quest)
				return true;
			end
		end
	end
	--- we've looked at all our current quests but not found a match
	return false;

end


function EquipIt(index)
	if (IsEquippableItem(DI_Item(index))) then
		return "\n/equip item:"..DI_Item(index);
	else
		return "";
	end
end

function UseIt(index)
	if DI_Item(index) then
		return "\n/use item:"..DI_Item(index);
	else
		return "";
	end
end


function TargetIt(index)
	if DI_Target(index) then
		if DI_TargetType(index) == 1 then
			if (DI_Target(index) == UnitName("target")) then  -- So we want to target but we are targetted so dont bother re-targetting - I think this is handled by the NoExists in the macro anyway 
				return "";
			else  -- - as if we have a target then (I think) the [noexists] means nothing happens anyway
				return "\n/target [noexists] "..DI_Target(index);
			end
		elseif (DI_TargetType(index) == 2) then -- Retarget no matter what This does NOT work very well on the few quests I've tried it on
			return "\n/target "..DI_Target(index);
		else -- Default target type - I think this is the original code (I re-structured a lot) - but since the macro isnt written UNLESS the target is already targetted I'm  not so sure that this does anything useful (as Noexists stops the retarget)
			return "\n/target [noexists] "..DI_Target(index);
		end
	else -- nothing to target
		return "";
	end 
end


function DailyItem_Go()

	local macroText;
	-- Process the database inthe outmost loop so that the LAST one found is the one we will keep - I think the previous version of code would of matched the last version in our current quest table
	for index = 1, DIQuestsLength -- Cycle through all quests in the database
	do
		if DailyItem_IsMatchQuest(index) then
			if DailyItem_IsZone(index) and DailyItem_IsSubZone(index) and DailyItem_IsMatchTarget(index) then -- Check if we're in the right part of the world and we are targetting the right thing
				if (DI_Item(index)) then -- Check if there is an associated item to use
					if DI_Paranoia>3 then print("DB ", index, " is in zone:", DI_Zone(index), " Subzone:" , DI_SubZone(index),DI_Item(index)," and we have the target ", DI_Target(index) , " of type ", DI_TargetType(index) ) ; end
					if DailyItem_IsItemInBags(DI_Item(index)) and IsEquippableItem(DI_Item(index)) then-- we have it in our bags but it should be equipped (trigger will fire when equipped)
						macroText = EquipIt(index);
						if( DI_Paranoia>0) then print(macroText, " due to ", index, DI_Quest (index), DI_Item(index)); end
					elseif DailyItem_IsItemInBags(DI_Item(index))  or DailyItem_IsItemWorn(DI_Item(index)) then  -- Do we have the item? (we have checked if it should be equipped so it does not matter where it is)
						-- if so then the macro will be Target then Use (the functions work out what to do)
						macroText = TargetIt(index)..UseIt(index) ;
						if( DI_Paranoia>0) then print(macroText, " due to ", index, DI_Quest (index), DI_Item(index)); end
					end -- Check for item
				else -- So there is no item for this quest
					macroText = TargetIt(index);
					if( DI_Paranoia>0) then print(macroText, " due to ", index, DI_Quest (index), DI_Item(index)); end
				end -- Is there an item associated with quest
			end -- Zonecheck
		end -- Found a match to the current Database quest
	end -- Cycling through each quest in my log

	if (macroText) then -- So, we've decided what we want in our macro, so write it out (only if there's something to write)
		EditMacro(DailyItem_MACRONAME, nil, "INV_MISC_QUESTIONMARK" , "#showtooltip\n"..macroText, nil, nil);   --whoch should work
	else
		if DI_Paranoia>1 then print("Nothing found"); end
		--EditMacro(DailyItem_MACRONAME, nil, "INV_MISC_QUESTIONMARK", "/sleep", nil, nil);
	end -- Writing out macro

end -- End of the main function.
